{
    :
    -   
    -     
    -    ,   ..
    -   
    -  (Edge)    
    -   
    -   
    - Splitter
    -   SystemTray (  )
    - CheckList (ListBox + CheckBox)
    - CheckTree ( CheckBox     )
    -       (ico, exe, dll)
    -     (  " ")
    -  " " (  WinNT)
    -   
    -    ( ) 

   . 
  E-mail: roman@infra.sar.nnov.ru
}

unit Ex_Controls;

interface

uses
  Windows, ShellAPI, ShlObj, SysUtils, Messages, Classes, Graphics,
  Controls, Forms, Menus, StdCtrls, CommCtrl, ComCtrls, Registry,
  Ex_Utils;

type

{ TFormSizer }

  TSizeOption = (soSetMinWidth, soSetMinHeight, soSetMaxWidth, soSetMaxHeight,
    soAlwaysOnDisplay, soMaximizeToScreen);
  TSizeOptions = set of TSizeOption;

  TSizingEvent = procedure(Sender: TObject; Side: Integer; var Rect: TRect) of object;

  TFormSizer = class(TComponent)
  private
    FForm: TForm;
    FFormHook: TWndHook;
    FMinWidth: Integer;
    FMinHeight: Integer;
    FMaxWidth: Integer;
    FMaxHeight: Integer;
    FOptions: TSizeOptions;
    FOnMaximized: TNotifyEvent;
    FOnMinimized: TNotifyEvent;
    FOnRestored: TNotifyEvent;
    FOnSizing: TSizingEvent;
    procedure FormProc(var Message: TMessage);
    procedure GetBoundsInfo(var Left, Top, Width, Height: Integer);
    procedure GetMaximizedInfo(var MaxPosition, MaxSize: TPoint);
    procedure GetMinMaxInfo(var MinSize, MaxSize: TPoint);
    procedure GetSizeInfo(Side: Integer; var Rect: TRect);
  protected
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function ScreenHeight: Integer;
    function ScreenWidth: Integer;
  published
    property MinWidth: Integer read FMinWidth write FMinWidth;
    property MinHeight: Integer read FMinHeight write FMinHeight;
    property MaxWidth: Integer read FMaxWidth write FMaxWidth;
    property MaxHeight: Integer read FMaxHeight write FMaxHeight;
    property Options: TSizeOptions read FOptions write FOptions;
    property OnMaximized: TNotifyEvent read FOnMaximized write FOnMaximized;
    property OnMinimized: TNotifyEvent read FOnMinimized write FOnMinimized;
    property OnRestored: TNotifyEvent read FOnRestored write FOnRestored;
    property OnSizing: TSizingEvent read FOnSizing write FOnSizing;
  end;

  { TFormPlacement }

  TPlacement = record
    Left: Integer;
    Top: Integer;
    Width: Integer;
    Height: Integer;
    State: Integer;
  end;

  TPlacementOption = (poOrigin, poSize, poState);
  TPlacementOptions = set of TPlacementOption;

  TLoadPlacementEvent = procedure(Sender: TObject; IniFile: TRegIniFile) of object;
  TSavePlacementEvent = procedure(Sender: TObject; IniFile: TRegIniFile) of object;

  TFormPlacement = class(TComponent)
  private
    FForm: TForm;
    FFormHook: TWndHook;
    FKey: string;
    FOptions: TPlacementOptions;
    FAutoPlace: Boolean;
    FOnLoad: TLoadPlacementEvent;
    FOnSave: TSavePlacementEvent;
    procedure FormProc(var Message: TMessage);
    function GetFormPlacement: TPlacement;
    procedure SetFormPlacement(Value: TPlacement);
  protected
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure LoadPlacement;
    procedure SavePlacement;
  published
    property AutoPlace: Boolean read FAutoPlace write FAutoPlace;
    property Options: TPlacementOptions read FOptions write FOptions;
    property Key: string read FKey write FKey;
    property OnLoad: TLoadPlacementEvent read FOnLoad write FOnLoad;
    property OnSave: TSavePlacementEvent read FOnSave write FOnSave;
  end;

{ TPreventer }

  TPreventOption = (poMove, poResize, poResizeLeft, poResizeRight, poResizeTop,
    poResizeTopLeft, poResizeTopRight, poResizeBottom, poResizeBottomLeft,
    poResizeBottomRight, poMinimize, poMaximize, poClose, poVisible);
  TPreventOptions = set of TPreventOption;

  TPreventer = class(TComponent)
  private
    FOptions: TPreventOptions;
    procedure SetOptions(Value: TPreventOptions);
  protected
    procedure Loaded; override;
    procedure Prevent; virtual; abstract;
  published
    property Options: TPreventOptions read FOptions write SetOptions;
  end;

{ TFormPreventer }

  TFormPreventer = class(TPreventer)
  private
    FForm: TForm;
    FFormHook: TWndHook;
    procedure FormProc(var Message: TMessage);
  protected
    procedure Loaded; override;
    procedure Prevent; override;
  public
    destructor Destroy; override;
  end;

{ TAppPreventer }

  TAppPreventer = class(TPreventer)
  protected
    procedure Prevent; override;
  end;

{ TFormHook }

  THookEvent = procedure(var Message: TMessage; var Handled: Boolean) of object;

  TFormHook = class(TComponent)
  private
    FFormHook: TWndHook;
    FOnEnter: THookEvent;
    FOnExit: THookEvent;
    procedure FormProc(var Message: TMessage);
  protected
    procedure Enter(var Message: TMessage; var Handled: Boolean); virtual;
    procedure Exit(var Message: TMessage; var Handled: Boolean); virtual;
    procedure Loaded; override;
  public
    destructor Destroy; override;
  published
    property OnEnter: THookEvent read FOnEnter write FOnEnter;
    property OnExit: THookEvent read FOnExit write FOnExit;
  end;

{ TFormEdge }

  TFormEdge = class(TComponent)
  private
    FVisible: Boolean;
    procedure SetVisible(Value: Boolean);
    procedure UpdateEdge;
  protected
    procedure Loaded; override;
  published
    property Visible: Boolean read FVisible write SetVisible;
  end;

{ TAppHook }

  TAppHookOption = (ahEvents, ahMessages);
  TAppHookOptions = set of TAppHookOption;

  TAppHook = class(TComponent)
  private
    FAppHook: TWndHook;
    FOptions: TAppHookOptions;
    FOnAppException: TExceptionEvent;
    FOnAppMessage: TMessageEvent;
    FOnAppHelp: THelpEvent;
    FOnAppHint: TNotifyEvent;
    FOnAppIdle: TIdleEvent;
    FOnAppDeactivate: TNotifyEvent;
    FOnAppActivate: TNotifyEvent;
    FOnAppShowHint: TShowHintEvent;
    FOnAppMinimize: TNotifyEvent;
    FOnAppRestore: TNotifyEvent;
    FOnEnter: THookEvent;
    FOnExit: THookEvent;
    procedure AppProc(var Message: TMessage);
  protected
    procedure Enter(var Message: TMessage; var Handled: Boolean); virtual;
    procedure Exit(var Message: TMessage; var Handled: Boolean); virtual;
    procedure Loaded; override;
  public
    destructor Destroy; override;
  published
    property Options: TAppHookOptions read FOptions write FOptions;
    property OnAppActivate: TNotifyEvent read FOnAppActivate write FOnAppActivate;
    property OnAppDeactivate: TNotifyEvent read FOnAppDeactivate write FOnAppDeactivate;
    property OnAppException: TExceptionEvent read FOnAppException write FOnAppException;
    property OnAppIdle: TIdleEvent read FOnAppIdle write FOnAppIdle;
    property OnAppHelp: THelpEvent read FOnAppHelp write FOnAppHelp;
    property OnAppHint: TNotifyEvent read FOnAppHint write FOnAppHint;
    property OnAppMessage: TMessageEvent read FOnAppMessage write FOnAppMessage;
    property OnAppMinimize: TNotifyEvent read FOnAppMinimize write FOnAppMinimize;
    property OnAppRestore: TNotifyEvent read FOnAppRestore write FOnAppRestore;
    property OnAppShowHint: TShowHintEvent read FOnAppShowHint write FOnAppShowHint;
    property OnEnter: THookEvent read FOnEnter write FOnEnter;
    property OnExit: THookEvent read FOnExit write FOnExit;
  end;

{ TAppInstance }

  TAppInstance = class(TComponent)
  private
    FAppName: string;
    FAppMessage: Integer;
    FAppMutex: THandle;
    FOnActivate: TNotifyEvent;
    FOnHalt: TNotifyEvent;
    function AppHook(var Message: TMessage): Boolean;
  protected
    procedure Activate; dynamic;
    procedure Halt; dynamic;
    procedure Loaded; override;
  public
    destructor Destroy; override;
  published
    property AppName: string read FAppName write FAppName;
    property OnActivate: TNotifyEvent read FOnActivate write FOnActivate;
    property OnHalt: TNotifyEvent read FOnHalt write FOnHalt;
  end;

{ TSplitPanel }

  TBorderStyle = (bsNone, bsRaised, bsLowered);

  TSplitMode = (spUnknown, spLeft, spTop, spRight, spBottom);
  TInverseMode = (imNew, imClear, imMove);

  TSplitPanel = class(TCustomControl)
  private
    FControl: TControl;
    FMin: Integer;
    FMax: Integer;
    FBorderStyle: TBorderStyle;
    FLimits: TRect;
    FSaveX: Integer;
    FSaveY: Integer;
    FMode: TSplitMode;
    FSplitting: Boolean;
    FPrevOrg: TPoint;
    FOnSplit: TNotifyEvent;
    procedure CheckPosition(var X, Y: Integer);
    function GetMode: TSplitMode;
    procedure SetBorderStyle(Value: TBorderStyle);
    procedure SetControl(Value: TControl);
    procedure SetMin(Value: Integer);
    procedure SetMax(Value: Integer);
    procedure ShowSplitRect(X, Y: Integer; Mode: TInverseMode);
    procedure StartSplit(X, Y: Integer);
    procedure StepSplit(X, Y: Integer);
    procedure StopSplit(X, Y: Integer);
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure Notification(AComponent: TComponent; AOperation: TOperation); override;
    procedure Paint; override;
    procedure Split; dynamic;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Align;
    property Enabled;
    property BorderStyle: TBorderStyle read FBorderStyle write SetBorderStyle;
    property Color;
    property Control: TControl read FControl write SetControl;
    property Cursor;
    property Max: Integer read FMax write SetMax;
    property Min: Integer read FMin write SetMin;
    property ParentColor;
    property ParentShowHint;
    property ShowHint;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnSplit: TNotifyEvent read FOnSplit write FOnSplit;
  end;

  { TTrayIcon }

  TTrayIcon = class(TComponent)
  private
    FHandle: HWnd;
    FData: TNotifyIconData;
    FVisible: Boolean;
    FIcon: TIcon;
    FIconID: Integer;
    FHint: string;
    FPopupMenu: TPopupMenu;
    FOnClick: TNotifyEvent;
    FOnDblClick: TNotifyEvent;
    procedure IconChange(Sender: TObject);
    procedure SetIcon(Value: TIcon);
    procedure SetIconID(Value: Integer);
    procedure SetHint(Value: string);
    procedure SetPopupMenu(Value: TPopupMenu);
    procedure SetVisible(Value: Boolean);
    procedure WndProc(var Message: TMessage);
    procedure UpdateIcon;
  protected
    procedure Click; dynamic;
    procedure DblClick; dynamic;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure Popup; dynamic;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Icon: TIcon read FIcon write SetIcon;
    property IconID: Integer read FIconID  write SetIconID;
    property Hint: string read FHint write SetHint;
    property PopupMenu: TPopupMenu read FPopupMenu write SetPopupMenu;
    property Visible: Boolean read FVisible write SetVisible;
    property OnClick: TNotifyEvent read FOnClick write FOnClick;
    property OnDblClick: TNotifyEvent read FOnDblClick write FOnDblClick;
  end;

{ TCheckList }

  TCheckState = class
  public
    Checked: Boolean;
    State: TCheckBoxState;
  end;

  TCheckList = class(TCustomListBox)
  private
    FStateList: TList;
    FBitmap: TBitmap;
    FBitmap95: TBitmap;
    FBitmap3D: TBitmap;
    FCheck3D: Boolean;
    FCheck95: Boolean;
    FHideSelection: Boolean;
    procedure ClearStateList;
    function GetChecked(Index: Integer): Boolean;
    function GetCheckRect(Index: Integer): TRect;
    function GetState(Index: Integer): TCheckBoxState;
    procedure SetCheck3D(Value: Boolean);
    procedure SetCheck95(Value: Boolean);
    procedure SetChecked(Index: Integer; Value: Boolean);
    procedure SetHideSelection(Value: Boolean);
    procedure SetState(Index: Integer; Value: TCheckBoxState);
    procedure ValidateCheck(Index: Integer);
    procedure ValidateIndex(Index: Integer);
    procedure CNDrawItem(var Message: TWMDrawItem); message CN_DRAWITEM;
  protected
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Checked[Index: Integer]: Boolean read GetChecked write SetChecked;
    property State[Index: Integer]: TCheckBoxState read GetState write SetState;
  published
    property Align;
    property BorderStyle;
    property Check3D: Boolean read FCheck3D write SetCheck3D default False;
    property Check95: Boolean read FCheck95 write SetCheck95 default True;
    property Color;
    property Columns;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection: Boolean read FHideSelection write SetHideSelection default False;
    property IntegralHeight;
    property ItemHeight;
    property Items;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Sorted;
    property TabOrder;
    property TabWidth;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDrawItem;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

{ TCheckTree }

  TCheckTree = class(TCustomTreeView)
  private
    FImages: TImageList;
    FImages95: TImageList;
    FImages3D: TImageList;
    FCheck3D: Boolean;
    FCheck95: Boolean;
    FCheckChild: Boolean;
    function GetChecked(Node: TTreeNode): Boolean;
    function GetState(Node: TTreeNode): TCheckBoxState;
    procedure SetCheck3D(Value: Boolean);
    procedure SetCheck95(Value: Boolean);
    procedure SetChecked(Node: TTreeNode; Value: Boolean);
    procedure SetState(Node: TTreeNode; Value: TCheckBoxState);
  protected
    procedure ApplyImage(Node: TTreeNode; ImageIndex: Integer);
    procedure CheckChildren(Node: TTreeNode); dynamic;
    procedure CheckParent(Parent: TTreeNode); dynamic;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Checked[Node: TTreeNode]: Boolean read GetChecked write SetChecked;
    property State[Node: TTreeNode]: TCheckBoxState read GetState write SetState;
  published
    property Align;
    property BorderStyle;
    property Check3D: Boolean read FCheck3D write SetCheck3D default False;
    property Check95: Boolean read FCheck95 write SetCheck95 default True;
    property CheckChild: Boolean read FCheckChild write FCheckChild default False;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property Indent;
    property Items;
    property ParentColor;
    property ParentCtl3D;
    property PopupMenu;
    property ParentFont;
    property ParentShowHint;
    property ReadOnly;
    property ShowButtons;
    property ShowHint;
    property ShowLines;
    property ShowRoot;
    property TabOrder;
    property TabStop default True;
    property Visible;
    property OnChange;
    property OnChanging;
    property OnClick;
    property OnCollapsed;
    property OnCollapsing;
    property OnDblClick;
    property OnDeletion;
    property OnEdited;
    property OnEditing;
    property OnEnter;
    property OnExit;
    property OnExpanded;
    property OnExpanding;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

{ TIconBox }

  TIconBox = class(TCustomListBox)
  private
    FIconFile: string;
    FOnChange: TNotifyEvent;
    procedure CreateList;
    procedure DestroyList;
    function GetIcon(Index: Integer): TIcon;
    function GetIconCount: Integer;
    function GetIconIndex: Integer;
    function GetIconPath: string;
    procedure SetIcon(Index: Integer; Value: TIcon);
    procedure SetIconIndex(Value: Integer);
    procedure SetIconFile(Value: string);
    procedure SetIconPath(Value: string);
    procedure CNDrawItem(var Message: TWMDrawItem); message CN_DRAWITEM;
  protected
    procedure Change; virtual;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure DestroyWnd; override;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
    procedure MeasureItem(Index: Integer; var Height: Integer); override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;
    property Icons[Index: Integer]: TIcon read GetIcon write SetIcon;
    property IconCount: Integer read GetIconCount;
  published
    property Color;
    property Ctl3D;
    property Enabled;
    property Font;
    property IconIndex: Integer read GetIconIndex write SetIconIndex;
    property IconFile: string read FIconFile write SetIconFile;
    property IconPath: string read GetIconPath write SetIconPath;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick;
    property OnDblClick;
    property OnEnter;
    property OnExit;
  end;

{ TIconDialog }

  TIconDialog = class(TComponent)
  private
    FIconPath: string;
    function GetIconIndex: Integer;
    function GetIconFile: string;
    procedure SetIconIndex(Value: Integer);
    procedure SetIconFile(Value: string);
  public
    function Execute: Boolean;
  published
    property IconIndex: Integer read GetIconIndex write SetIconIndex;
    property IconFile: string read GetIconFile write SetIconFile;
    property IconPath: string read FIconPath write FIconPath;
  end;

{ TAboutDialog }

  TAboutDialog = class(TComponent)
  private
    FProduct: string;
    FVersion: string;
    FCopyright: string;
    FAdditional: string;
    FCaption: string;
    FPicture: TPicture;
    FKey: string;
    procedure SetPicture(Value: TPicture);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Execute: Boolean;
  published
    property Additional: string read FAdditional write FAdditional;
    property Caption: string read FCaption write FCaption;
    property Copyright: string read FCopyright write FCopyright;
    property Picture: TPicture read FPicture write SetPicture;
    property Product: string read FProduct write FProduct;
    property Version: string read FVersion write FVersion;
    property Key: string read FKey write FKey;
  end;

{ TFolderDialog }

  TDialogPosition = (poScreenCenter, poDefault);

  TFolderDialog = class(TComponent)
  private
    FCaption: string;
    FTitle: string;
    FFolder: string;
    FPosition: TDialogPosition;
    procedure Init(Wnd: HWND);
  public
    function Execute: Boolean;
  published
    property Caption: string read FCaption write FCaption;
    property Folder: string read FFolder write FFolder;
    property Position: TDialogPosition read FPosition write FPosition;
    property Title: string read FTitle write FTitle;
  end;

{ TFileDialog }

  TCreateFolderEvent = procedure(Sender: TObject; FolderItem: TListItem; var AllowCreate: Boolean) of object;
  TDeleteFileEvent = procedure(Sender: TObject; FileItem: TListItem; var AllowDelete: Boolean) of object;
  TRenamingFileEvent = procedure(Sender: TObject; FileItem: TListItem; var AllowRename: Boolean) of object;
  TRenamedFileEvent = procedure(Sender: TObject; FileItem: TListItem; var S: string) of object;
  TOpenFileEvent = procedure(Sender: TObject; FileItem: TListItem; var AllowOpen: Boolean) of object;

  TFileDialog = class(TComponent)
  private
    FCaption: TCaption;
    FFolderLabel: TCaption;
    FFolder: string;
    FFileNameLabel: TCaption;
    FFileName: string;
    FFileTypeLabel: TCaption;
    FFileType: string;
    FOpenCaption: TCaption;
    FEnableUp: Boolean;
    FEnableCreate: Boolean;
    FEnableOpen: Boolean;
    FEnableRename: Boolean;
    FEnableDelete: Boolean;
    FPopupMenu: TPopupMenu;
    FDialogForm: TForm;
    FOnInitDialog: TNotifyEvent;
    FOnDoneDialog: TNotifyEvent;
    FOnCancelDialog: TNotifyEvent;
    FOnRefreshDialog: TNotifyEvent;
    FOnChangeFolder: TNotifyEvent;
    FOnChangeFileName: TNotifyEvent;
    FOnChangeFileType: TNotifyEvent;
    FOnCreateFolder: TCreateFolderEvent;
    FOnUpFolder: TNotifyEvent;
    FOnDeleteFile: TDeleteFileEvent;
    FOnRenamingFile: TRenamingFileEvent;
    FOnRenamedFile: TRenamedFileEvent;
    FOnOpenFile: TOpenFileEvent;
    procedure ChangeFileName(Sender: TObject);
    procedure ChangeFileType(Sender: TObject);
    procedure ChangeFolder(Sender: TObject);
    procedure CreateFolder(Sender: TObject);
    procedure DialogCancel(Sender: TObject);
    procedure DialogKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FileKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FileOpen(Sender: TObject);
    procedure FileRenamed(Sender: TObject; Item: TListItem; var S: string);
    procedure FileRenaming(Sender: TObject; Item: TListItem; var AllowEdit: Boolean);
    function GetFileImages: TImageList;
    function GetFileList: TListItems;
    function GetFileListColumns: TListColumns;
    function GetFileNameItem: TListItem;
    function GetFileTypeIndex: Integer;
    function GetFileTypeList: TStrings;
    function GetFolderIndex: Integer;
    function GetFolderList: TStrings;
    function GetIsRenaming: Boolean;
    procedure SetCaption(Value: TCaption);
    procedure SetEnableCreate(Value: Boolean);
    procedure SetEnableOpen(Value: Boolean);
    procedure SetEnableRename(Value: Boolean);
    procedure SetEnableUp(Value: Boolean);
    procedure SetFileList(Value: TListItems);
    procedure SetFileListColumns(Value: TListColumns);
    procedure SetFileName(Value: string);
    procedure SetFileNameLabel(Value: TCaption);
    procedure SetFileType(Value: string);
    procedure SetFileTypeIndex(Value: Integer);
    procedure SetFileTypeLabel(Value: TCaption);
    procedure SetFileTypeList(Value: TStrings);
    procedure SetFolder(Value: string);
    procedure SetFolderIndex(Value: Integer);
    procedure SetFolderLabel(Value: TCaption);
    procedure SetFolderList(Value: TStrings);
    procedure SetOpenCaption(Value: TCaption);
    procedure SetPopupMenu(Value: TPopupMenu);
    procedure UpFolder(Sender: TObject);
  protected
    procedure CancelDialog; virtual;
    procedure DoneDialog; virtual;
    procedure InitDialog; virtual;
    procedure RefreshDialog; virtual;
    property Dialog: TForm read FDialogForm;
  public
    constructor Create(AOwner: TComponent); override;
    procedure DoCancelDialog;
    procedure DoCancelRename;
    procedure DoCreateFolder;
    procedure DoDeleteFile;
    procedure DoOpenFile;
    procedure DoPopup;
    procedure DoRefreshDialog;
    procedure DoRenameFile;
    procedure DoUpFolder;
    function Execute: Boolean;
    function ExecutePos(X, Y: Integer): Boolean;
    property FileImages: TImageList read GetFileImages;
    property FileList: TListItems read GetFileList write SetFileList;
    property FileListColumns: TListColumns read GetFileListColumns write SetFileListColumns;
    property FileNameItem: TListItem read GetFileNameItem;
    property FileTypeIndex: Integer read GetFileTypeIndex write SetFileTypeIndex;
    property FileTypeList: TStrings read GetFileTypeList write SetFileTypeList;
    property FolderIndex: Integer read GetFolderIndex write SetFolderIndex;
    property FolderList: TStrings read GetFolderList write SetFolderList;
    property IsRenaming: Boolean read GetIsRenaming;
  published
    property Caption: TCaption read FCaption write SetCaption;
    property EnableCreate: Boolean read FEnableCreate write SetEnableCreate;
    property EnableDelete: Boolean read FEnableDelete write FEnableDelete;
    property EnableOpen: Boolean read FEnableOpen write SetEnableOpen;
    property EnableRename: Boolean read FEnableRename write SetEnableRename;
    property EnableUp: Boolean read FEnableUp write SetEnableUp;
    property FileName: string read FFileName write SetFileName;
    property FileNameLabel: TCaption read FFileNameLabel write SetFileNameLabel;
    property FileTypeLabel: TCaption read FFileTypeLabel write SetFileTypeLabel;
    property FileType: string read FFileType write SetFileType;
    property FolderLabel: TCaption read FFolderLabel write SetFolderLabel;
    property Folder: string read FFolder write SetFolder;
    property OpenCaption: TCaption read FOpenCaption write SetOpenCaption;
    property PopupMenu: TPopupMenu read FPopupMenu write SetPopupMenu;
    property OnCancelDialog: TNotifyEvent read FOnCancelDialog write FOnCancelDialog;
    property OnChangeFileName: TNotifyEvent read FOnChangeFileName write FOnChangeFileName;
    property OnChangeFileType: TNotifyEvent read FOnChangeFileType write FOnChangeFileType;
    property OnChangeFolder: TNotifyEvent read FOnChangeFolder write FOnChangeFolder;
    property OnCreateFolder: TCreateFolderEvent read FOnCreateFolder write FOnCreateFolder;
    property OnDeleteFile: TDeleteFileEvent read FOnDeleteFile write FOnDeleteFile;
    property OnDoneDialog: TNotifyEvent read FOnDoneDialog write FOnDoneDialog;
    property OnInitDialog: TNotifyEvent read FOnInitDialog write FOnInitDialog;
    property OnOpenFile: TOpenFileEvent read FOnOpenFile write FOnOpenFile;
    property OnRefreshDialog: TNotifyEvent read FOnRefreshDialog write FOnRefreshDialog;
    property OnRenamedFile: TRenamedFileEvent read FOnRenamedFile write FOnRenamedFile;
    property OnRenamingFile: TRenamingFileEvent read FOnRenamingFile write FOnRenamingFile;
    property OnUpFolder: TNotifyEvent read FOnUpFolder write FOnUpFolder;
  end;

function BroadcastSysMessage(Flags: DWORD; Recipients: PDWORD; uiMessage: UINT; wParam: WPARAM; lParam: LPARAM): Longint; stdcall;

implementation

uses
  Ex_About, Ex_Icon, Ex_File;
  
{$R *.RES}

{ TFormSizer }

constructor TFormSizer.Create(AOwner: TComponent);
var
  R: TRect;
begin
  inherited Create(AOwner);
  FMinWidth := GetSystemMetrics(SM_CXMINTRACK);
  FMinHeight := GetSystemMetrics(SM_CYMINTRACK);
  SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
  FMaxWidth := R.Right - R.Left;
  FMaxHeight :=R.Bottom - R.Top;
  FOptions := [soSetMinWidth, soSetMinHeight, soMaximizeToScreen];
end;

destructor TFormSizer.Destroy;
begin
  FreeWndHook(FFormHook);
  inherited Destroy;
end;

procedure TFormSizer.FormProc(var Message: TMessage);
begin
  CallWndHook(FFormHook, Message);
  with Message do
    case Msg of
      WM_GETMINMAXINFO:
        with PMinMaxInfo(LParam)^ do
        begin
          GetMaximizedInfo(ptMaxPosition, ptMaxSize);
          GetMinMaxInfo(ptMinTrackSize, ptMaxTrackSize);
        end;
      WM_WINDOWPOSCHANGING:
        with PWindowPos(LParam)^ do
          GetBoundsInfo(X, Y, CX, CY);
      WM_SIZING:
        GetSizeInfo(wParam, PRect(lParam)^);
      WM_SIZE:
        case wParam of
          SIZE_MAXIMIZED: if Assigned(FOnMaximized) then FOnMaximized(Self);
          SIZE_MINIMIZED: if Assigned(FOnMinimized) then FOnMinimized(Self);
          SIZE_RESTORED: if Assigned(FOnRestored) then FOnRestored(Self);
        end;
    end;
end;

procedure TFormSizer.GetBoundsInfo(var Left, Top, Width, Height: Integer);
var
  R: TRect;
begin
  if soAlwaysOnDisplay in FOptions then
  begin
    SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
    if Left + Width > R.Right then Left := R.Right - Width;
    if Left < R.Left then Left := R.Left;
    if Top + Height > R.Bottom then Top := R.Bottom - Height;
    if Top < R.Top then Top := R.Top;
  end;
end;

procedure TFormSizer.GetMaximizedInfo(var MaxPosition, MaxSize: TPoint);
var
  R: TRect;
begin
  if soMaximizeToScreen in FOptions then
  begin
    SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
    MaxPosition.X := R.Left;
    MaxPosition.Y := R.Top;
    MaxSize.X := R.Right - R.Left;
    MaxSize.Y := R.Bottom - R.Top;
  end;
end;

procedure TFormSizer.GetMinMaxInfo(var MinSize, MaxSize: TPoint);
begin
  if soSetMinWidth in FOptions then MinSize.X := FMinWidth;
  if soSetMinHeight in FOptions then MinSize.Y := FMinHeight;
  if soSetMaxWidth in FOptions then MaxSize.X := FMaxWidth;
  if soSetMaxHeight in FOptions then MaxSize.Y := FMaxHeight;
end;

procedure TFormSizer.GetSizeInfo(Side: Integer; var Rect: TRect);
begin
  if Assigned(FOnSizing) then FOnSizing(Self, Side, Rect);
end;

procedure TFormSizer.Loaded;
begin
  if not (csDesigning in ComponentState) then
    if (Owner <> nil) and (Owner is TForm) then
    begin
      FForm := TForm(Owner);
      FFormHook := CreateWndHook(FForm.Handle, FormProc);
    end;
  inherited Loaded;
end;

function TFormSizer.ScreenHeight: Integer;
var
  R: TRect;
begin
  SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
  Result := R.Bottom - R.Top;
end;

function TFormSizer.ScreenWidth: Integer;
var
  R: TRect;
begin
  SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
  Result := R.Right - R.Left;
end;

{ TFormPlacement }

constructor TFormPlacement.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FOptions := [poOrigin, poSize, poState];
  FAutoPlace := True;
  FKey := '';
end;

destructor TFormPlacement.Destroy;
begin
  FreeWndHook(FFormHook);
  inherited Destroy;
end;

procedure TFormPlacement.FormProc(var Message: TMessage);
begin
  if AutoPlace and (Message.Msg = WM_DESTROY) then SavePlacement;
  CallWndHook(FFormHook, Message);
end;

function TFormPlacement.GetFormPlacement: TPlacement;
var
  Placement: TWindowPlacement;
begin
  Placement.Length := SizeOf(TWindowPlacement);
  GetWindowPlacement(FForm.Handle, @Placement);
  with Placement.rcNormalPosition do
  begin
    Result.Left := Left;
    Result.Top := Top;
    Result.Width := Right - Left;
    Result.Height := Bottom - Top;
  end;
  Result.State := Ord(FForm.WindowState);
end;

procedure TFormPlacement.SetFormPlacement(Value: TPlacement);
begin
  with Value do
  begin
    FForm.SetBounds(Left, Top, Width, Height);
    FForm.WindowState := TWindowState(State);
  end;
end;

procedure TFormPlacement.Loaded;
begin
  if not (csDesigning in ComponentState) then
    if (Owner <> nil) and (Owner is TForm) then
    begin
      FForm := TForm(Owner);
      FFormHook := CreateWndHook(FForm.Handle, FormProc);
      if AutoPlace then LoadPlacement;
    end;
  inherited Loaded;
end;

procedure TFormPlacement.LoadPlacement;
var
  IniFile: TRegIniFile;
  Placement: TPlacement;
begin
  if FForm <> nil then
  begin
    IniFile := TRegIniFile.Create(FKey);
    try
      Placement := GetFormPlacement;
      with Placement do
      begin
        if poOrigin in FOptions then
        begin
          Left := Inifile.ReadInteger('', 'Left', Left);
          Top := Inifile.ReadInteger('', 'Top', Top);
        end;
        if poSize in FOptions then
        begin
          Width := Inifile.ReadInteger('', 'Width', Width);
          Height := Inifile.ReadInteger('', 'Height', Height);
        end;
        if poState in FOptions then
          State := Inifile.ReadInteger('', 'State', State);
      end;
      SetFormPlacement(Placement);
      if Assigned(FOnLoad) then FOnLoad(Self, IniFile);
    finally
      Inifile.Free;
    end;
  end;
end;

procedure TFormPlacement.SavePlacement;
var
  IniFile: TRegIniFile;
  Placement: TPlacement;
begin
  if FForm <> nil then
  begin
    IniFile := TRegIniFile.Create(FKey);
    try
      Placement := GetFormPlacement;
      with Placement do
      begin
        if poOrigin in FOptions then
        begin
          IniFile.WriteInteger('', 'Left', Left);
          IniFile.WriteInteger('', 'Top', Top);
        end;
        if poSize in FOptions then
        begin
          IniFile.WriteInteger('', 'Width', Width);
          IniFile.WriteInteger('', 'Height', Height);
        end;
        if poState in FOptions then
          Inifile.WriteInteger('', 'State', State);
      end;
      if Assigned(FOnSave) then FOnSave(Self, IniFile);
    finally
      IniFile.Free;
    end;
  end;
end;

{ TPreventer }

function NeedPrevent(Permission, Mode: TPreventOptions): Boolean;
begin
  Result := Mode * Permission = Mode;
end;

procedure TPreventer.SetOptions(Value: TPreventOptions);
begin
  FOptions := Value;
  Prevent;
end;

procedure TPreventer.Loaded;
begin
  Prevent;
  inherited Loaded;
end;

{ TFormPreventer }

destructor TFormPreventer.Destroy;
begin
  FreeWndHook(FFormHook);
  inherited Destroy;
end;

procedure TFormPreventer.FormProc(var Message: TMessage);
const
  SizeHit = [HTLEFT, HTRIGHT, HTBOTTOM, HTTOP, HTTOPLEFT, HTTOPRIGHT,
  HTBOTTOMRIGHT, HTBOTTOMLEFT];
begin
  with Message do
    if Msg = WM_CLOSE then
      if NeedPrevent(FOptions, [poClose]) then Exit;
  CallWndHook(FFormHook, Message);
  with Message do
    if Msg = WM_NCHITTEST then
    begin
      if (Result in SizeHit) and NeedPrevent(FOptions, [poResize]) then Result := 0;
      if (Result = HTLEFT) and NeedPrevent(FOptions, [poResizeLeft]) then Result := 0;
      if (Result = HTRIGHT) and NeedPrevent(FOptions, [poResizeRight]) then Result := 0;
      if (Result = HTTOP) and NeedPrevent(FOptions, [poResizeTop]) then Result := 0;
      if (Result = HTTOPLEFT) and NeedPrevent(FOptions, [poResizeTopLeft]) then Result := 0;
      if (Result = HTTOPRIGHT) and NeedPrevent(FOptions, [poResizeTopRight]) then Result := 0;
      if (Result = HTBOTTOM) and NeedPrevent(FOptions, [poResizeBottom]) then Result := 0;
      if (Result = HTBOTTOMLEFT) and NeedPrevent(FOptions, [poResizeBottomLeft]) then Result := 0;
      if (Result = HTBOTTOMRIGHT) and NeedPrevent(FOptions, [poResizeBottomRight]) then Result := 0;
    end;
end;

procedure TFormPreventer.Loaded;
begin
  if not (csDesigning in ComponentState) then
    if (Owner <> nil) and (Owner is TForm) then
    begin
      FForm := TForm(Owner);
      FFormHook := CreateWndHook(FForm.Handle, FormProc);
    end;
  inherited Loaded;
end;

procedure TFormPreventer.Prevent;
var
  SysMenu: HMENU;
begin
  if not (csDesigning in ComponentState) and (FForm <> nil) then
  begin
    with FForm do
    begin
      SysMenu := GetSystemMenu(Handle, False);
      SendMessage(Handle, WM_INITMENUPOPUP, SysMenu, MakeLong(0, 1));
      SysMenu := GetSystemMenu(Handle, False);
    end;
    if NeedPrevent(FOptions, [poMove]) then DeleteMenu(SysMenu, SC_MOVE, MF_BYCOMMAND);
    if NeedPrevent(FOptions, [poResize]) then DeleteMenu(SysMenu, SC_SIZE, MF_BYCOMMAND);
    if NeedPrevent(FOptions, [poMinimize]) then DeleteMenu(SysMenu, SC_MINIMIZE, MF_BYCOMMAND);
    if NeedPrevent(FOptions, [poMaximize]) then DeleteMenu(SysMenu, SC_MAXIMIZE, MF_BYCOMMAND);
    if NeedPrevent(FOptions, [poMinimize, poMaximize]) then DeleteMenu(SysMenu, SC_RESTORE, MF_BYCOMMAND);
    if NeedPrevent(FOptions, [poClose]) then EnableMenuItem(SysMenu, SC_CLOSE, MF_BYCOMMAND or MF_GRAYED);
  end;
end;

{ TAppPreventer }

procedure TAppPreventer.Prevent;
var
  AppMenu: HMENU;
begin
  if not (csDesigning in ComponentState) then
  begin
    with Application do
    begin
      AppMenu := GetSystemMenu(Handle, False);
      SendMessage(Handle, WM_INITMENUPOPUP, AppMenu, MakeLong(0, 1));
      AppMenu := GetSystemMenu(Handle, False);
    end;
    if NeedPrevent(FOptions, [poMinimize]) then
    begin
      DeleteMenu(AppMenu, 2, MF_BYPOSITION);
      DeleteMenu(AppMenu, SC_MINIMIZE, MF_BYCOMMAND);
      DeleteMenu(AppMenu, SC_RESTORE, MF_BYCOMMAND);
    end;
    if NeedPrevent(FOptions, [poClose]) then
    begin
      DeleteMenu(AppMenu, SC_CLOSE, MF_BYCOMMAND);
      DeleteMenu(AppMenu, 2, MF_BYPOSITION);
    end;
    if NeedPrevent(FOptions, [poVisible]) then
      ShowWindow(Application.Handle, SW_HIDE)
    else
      ShowWindow(Application.Handle, SW_SHOW);
  end;
end;

{ TFormHook }

destructor TFormHook.Destroy;
begin
  FreeWndHook(FFormHook);
  inherited Destroy;
end;

procedure TFormHook.FormProc(var Message: TMessage);
var
  Handled: Boolean;
begin
  try
    Enter(Message, Handled);
    if not Handled then
    begin
      CallWndHook(FFormHook, Message);
      Exit(Message, Handled);
    end;
  except
    Application.HandleException(Self);
  end;
end;

procedure TFormHook.Enter(var Message: TMessage; var Handled: Boolean);
begin
  Handled := False;
  if Assigned(FOnEnter) then FOnEnter(Message, Handled);
end;

procedure TFormHook.Exit(var Message: TMessage; var Handled: Boolean);
begin
  Handled := False;
  if Assigned(FOnExit) then FOnExit(Message, Handled);
end;

procedure TFormHook.Loaded;
begin
  if not (csDesigning in ComponentState) then
    if (Owner <> nil) and (Owner is TForm) then
      FFormHook := CreateWndHook(TForm(Owner).Handle, FormProc);
  inherited Loaded;
end;

{ TFormEdge }

procedure TFormEdge.SetVisible(Value: Boolean);
begin
  if FVisible <> Value then
  begin
    FVisible := Value;
    UpdateEdge;
  end;
end;

procedure TFormEdge.UpdateEdge;
const
  Flags = SWP_DRAWFRAME or SWP_NOMOVE or SWP_NOSIZE or SWP_NOZORDER;
var
  Handle: THandle;
  ExStyle: Longint;
begin
  if not (csDesigning in ComponentState) and (Owner <> nil) and (Owner is TForm) then
  begin
    if TForm(Owner).FormStyle = fsMDIForm then
      Handle := TForm(Owner).ClientHandle
    else
      Handle := TForm(Owner).Handle;
    ExStyle := GetWindowLong(Handle, GWL_EXSTYLE);
    if Visible then
      SetWindowLong(Handle, GWL_EXSTYLE, ExStyle or WS_EX_CLIENTEDGE)
    else
      SetWindowLong(Handle, GWL_EXSTYLE, ExStyle and not WS_EX_CLIENTEDGE);
    SetWindowPos(Handle, 0, 0, 0, 0, 0, Flags);
  end;
end;

procedure TFormEdge.Loaded;
begin
  UpdateEdge;
  inherited Loaded;
end;

{ TAppHook }

destructor TAppHook.Destroy;
begin
  FreeWndHook(FAppHook);
  inherited Destroy;
end;

procedure TAppHook.AppProc(var Message: TMessage);
var
  Handled: Boolean;
begin
  try
    Enter(Message, Handled);
    if not Handled then
    begin
      CallWndHook(FAppHook, Message);
      Exit(Message, Handled);
    end;
  except
    Application.HandleException(Self);
  end;
end;

procedure TAppHook.Enter(var Message: TMessage; var Handled: Boolean);
begin
  Handled := False;
  if Assigned(FOnEnter) then FOnEnter(Message, Handled);
end;

procedure TAppHook.Exit(var Message: TMessage; var Handled: Boolean); 
begin
  Handled := False;
  if Assigned(FOnExit) then FOnExit(Message, Handled);
end;

procedure TAppHook.Loaded;
begin
  if not (csDesigning in ComponentState) then
  begin
    if ahEvents in FOptions then
      with Application do
      begin
        OnException := FOnAppException;
        OnMessage := FOnAppMessage;
        OnHelp := FOnAppHelp;
        OnHint := FOnAppHint;
        OnIdle := FOnAppIdle;
        OnDeactivate := FOnAppDeactivate;
        OnActivate := FOnAppActivate;
        OnShowHint := FOnAppShowHint;
        OnMinimize := FOnAppMinimize;
        OnRestore := FOnAppRestore;
      end;
    if ahMessages in FOptions then
      FAppHook := CreateWndHook(Application.Handle, AppProc);
  end;
  inherited Loaded;
end;

{ TAppInstance }

function BroadcastSysMessage; external user32 name 'BroadcastSystemMessage';

destructor TAppInstance.Destroy;
begin
  Application.UnhookMainWindow(AppHook);
  CloseHandle(FAppMutex);
  inherited Destroy;
end;

function TAppInstance.AppHook(var Message: TMessage): Boolean;
begin
  Result := False;
  try
    if Message.Msg = FAppMessage then
    begin
      Activate;
      Result := True;
    end;
  except
    Application.HandleException(Self);
  end;
end;

procedure TAppInstance.Activate;
begin
  if Assigned(FOnActivate) then
  begin
    FOnActivate(Self);
    Exit;
  end;
  with Application do
  begin
    if IsIconic(Handle) then ShowWindow(Handle, SW_RESTORE);
    SetForegroundWindow(Handle);
  end;
end;

procedure TAppInstance.Halt;
begin
  if Assigned(FOnHalt) then FOnHalt(Self) else System.Halt;
end;

procedure TAppInstance.Loaded;
var
  AppMutex: THandle;
  Recipients: DWORD;
begin
  if not (csDesigning in ComponentState) then
  begin
    FAppMessage := RegisterWindowMessage(PChar(FAppName));
    AppMutex := OpenMutex(MUTEX_ALL_ACCESS, False, PChar(FAppName));
    if AppMutex = 0 then
    begin
      FAppMutex := CreateMutex(nil, False, PChar(FAppName));
      Application.HookMainWindow(AppHook);
    end
    else
    begin
      CloseHandle(AppMutex);
      Recipients := BSM_APPLICATIONS;
      BroadcastSysMessage(BSF_IGNORECURRENTTASK or BSF_POSTMESSAGE, @Recipients, FAppMessage, 0, 0);
      Halt;
    end;
  end;
  inherited Loaded;
end;

{ TSplitPanel }

constructor TSplitPanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [csCaptureMouse, csClickEvents, csDoubleClicks];
  Width := 185;
  Height := GetSystemMetrics(SM_CYFRAME);
  FMin := 4;
  FMax := 300;
end;

procedure TSplitPanel.CheckPosition(var X, Y: Integer);
begin
  if X < FLimits.Left then X := FLimits.Left;
  if X > FLimits.Right then X := FLimits.Right;
  if Y < FLimits.Top then Y := FLimits.Top;
  if Y > FLimits.Bottom then Y := FLimits.Bottom;
end;

function TSplitPanel.GetMode: TSplitMode;
begin
  Result := spUnknown;
  if HasParent and Assigned(Control) then
  begin
    if (Control.Align = alTop) and (Top > Control.Top) then Result := spTop
    else if (Control.Align = alBottom) and (Top < Control.Top) then Result := spBottom
    else if (Control.Align = alLeft) and (Left > Control.Left) then Result := spLeft
    else if (Control.Align = alRight) and (Left < Control.Left) then Result := spRight;
    if Align <> Control.Align then Result := spUnknown;
  end;
end;

procedure TSplitPanel.SetBorderStyle(Value: TBorderStyle);
begin
  if FBorderStyle <> Value then
  begin
    FBorderStyle := Value;
    Refresh;
  end;
end;

procedure TSplitPanel.SetControl(Value: TControl);
begin
  if (FControl <> Value) and (Value <> Self) then
  begin
    FControl := Value;
    case GetMode of
      spUnknown: Cursor := crDefault;
      spLeft, spRight: Cursor := crHSplit;
      spTop, spBottom: Cursor := crVSplit;
    end;
  end;
end;

procedure TSplitPanel.SetMin(Value: Integer);
begin
  if Value < 0 then FMin := 0 else FMin := Value;
  if FMax < Value then FMax := Value;
end;

procedure TSplitPanel.SetMax(Value: Integer);
begin
  if Value < 0 then FMax := 0 else FMax := Value;
  if FMin > Value then FMin := Value;
end;

procedure TSplitPanel.ShowSplitRect(X, Y: Integer; Mode: TInverseMode);
var
  P: TPoint;
  MaxRect: TRect;
  Horz: Boolean;

  procedure PaintInverseRect(RectOrg, RectEnd: TPoint);
  var
    DC: HDC;
    R, FR: TRect;
    I: Integer;
  begin
    DC := GetDC(0);
    try
      R := Rect(RectOrg.X, RectOrg.Y, RectEnd.X, RectEnd.Y);
      if FMode in [spTop, spBottom] then
      begin
        I := Ord(FBorderStyle <> bsNone) * 2;
        repeat
          FR := Rect(R.Left, R.Top + I, R.Right, R.Top + I);
          DrawFocusRect(DC, FR);
          Inc(I, 2);
        until I > R.Bottom - R.Top - 1;
      end
      else if FMode in [spLeft, spRight] then
      begin
        I := Ord(FBorderStyle <> bsNone) * 2;
        repeat
          FR := Rect(R.Left + I, R.Top, R.Left + I, R.Bottom);
          DrawFocusRect(DC, FR);
          Inc(I, 2);
        until I > R.Right - R.Left - 1;
      end;
    finally
      ReleaseDC(0, DC);
    end;
  end;

begin
  P := Point(0, 0);
  if FMode in [spTop, spBottom] then
  begin
    P.Y := Y;
    Horz := True;
  end
  else
  begin
    P.X := X;
    Horz := False;
  end;
  MaxRect := Parent.ClientRect;
  P := ClientToScreen(P);
  with P, MaxRect do
  begin
    TopLeft := Parent.ClientToScreen(TopLeft);
    BottomRight := Parent.ClientToScreen(BottomRight);
    if X < Left then X := Left;
    if X > Right then X := Right;
    if Y < Top then Y := Top;
    if Y > Bottom then Y := Bottom;
  end;
  if (Mode = imMove) then
    if ((P.X = FPrevOrg.X) and not Horz) or ((P.Y = FPrevOrg.Y) and Horz) then Exit;
  if Mode in [imClear, imMove] then
    PaintInverseRect(FPrevOrg, Point(FPrevOrg.X + Width, FPrevOrg.Y + Height));
  if Mode in [imNew, imMove] then
  begin
    PaintInverseRect(P, Point(P.X + Width, P.Y + Height));
    FPrevOrg := P;
  end;
end;

procedure TSplitPanel.StartSplit(X, Y: Integer);
var
  P, C: TRect;
begin
  with Parent do
  begin
    P := ClientRect;
    FLimits.TopLeft := ClientToScreen(Point(P.Left, P.Top));
    FLimits.BottomRight := ClientToScreen(Point(P.Right - P.Left, P.Bottom - P.Top));
  end;
  with Control do
  begin
    C.BottomRight := ClientToScreen(Point(Width, Height));
    C.TopLeft := ClientToScreen(Point(0, 0));
  end;
  FSaveX := 0;
  FSaveY := 0;
  case FMode of
    spLeft:
      begin
        FLimits.Bottom := C.Bottom - 1;
        if FMax > 0 then
          FLimits.Right := FLimits.Left + FMax
        else
          FLimits.Right := FLimits.Right - Width - 1;
        FLimits.Top := C.Top + 1;
        if FMin > 0 then
          FLimits.Left := FLimits.Left + FMin;
          FLimits.Left := FLimits.Left + 1; 
        FSaveX := X;
      end;
    spTop:
      begin
        if FMax > 0 then
          FLimits.Bottom := FLimits.Top + FMax
        else
          FLimits.Bottom := FLimits.Bottom - Height - 1;
        FLimits.Right := C.Right - 1;
        if FMin > 0 then
          FLimits.Top := FLimits.Top + FMin
        else
          FLimits.Top := FLimits.Top + 1;
        FLimits.Left := C.Left + 1;
        FSaveY := Y;
      end;
    spRight:
      begin
        if FMax > 0 then
          FLimits.Left := FLimits.Right - Width - FMax
        else
          FLimits.Left := FLimits.Left + 1;
        FLimits.Top := C.Top + 1;
        if FMin > 0 then
          FLimits.Right := FLimits.Right - Width - FMin
        else
          FLimits.Right := FLimits.Right - Width - 1;
        FLimits.Bottom := C.Bottom - 1;
        FSaveX := X;
      end;
    spBottom:
      begin
        FLimits.Left := C.Left + 1;
        if FMax> 0 then
          FLimits.Top := FLimits.Bottom - Height - FMax
        else
          FLimits.Top := FLimits.Top + 1;
        FLimits.Right := C.Right - 1;
        if FMin > 0 then
          FLimits.Bottom := FLimits.Bottom - Height - FMin
        else
          FLimits.Bottom := FLimits.Bottom - Height - 1;
        FSaveY := Y;
      end;
  end;
  FLimits.TopLeft := ScreenToClient(FLimits.TopLeft);
  FLimits.BottomRight := ScreenToClient(FLimits.BottomRight);
  ShowSplitRect(0, 0, imNew);
end;

procedure TSplitPanel.StepSplit(X, Y: Integer);
begin
  CheckPosition(X, Y);
  ShowSplitRect(X, Y, imMove);
end;

procedure TSplitPanel.StopSplit(X, Y: Integer);
const
  DecSize = 3;
var
  NewSize: Integer;
  Rect: TRect;
  W, H: Integer;
begin
  ShowSplitRect(0, 0, imClear);
  Rect := Parent.ClientRect;
  H := Rect.Bottom - Rect.Top - Height;
  W := Rect.Right - Rect.Left - Width;
  CheckPosition(X, Y);
  if FMode in [spTop, spBottom] then
  begin
    if FMode = spTop then
      NewSize := Control.Height + Y
    else
      NewSize := Control.Height - Y;
    if NewSize <= 0 then NewSize := 1;
    if NewSize >= H then NewSize := H - DecSize;
    Control.Height := NewSize;
  end
  else if FMode in [spLeft, spRight] then
  begin
    if FMode = spLeft then
      NewSize := Control.Width + X
    else
      NewSize := Control.Width - X;
    if NewSize <= 0 then NewSize := 1;
    if NewSize >= W then NewSize := W - DecSize;
    Control.Width := NewSize;
  end;
end;

procedure TSplitPanel.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if not (csDesigning in ComponentState) and (Button = mbLeft) then
  begin
    FMode := GetMode;
    if FMode <> spUnknown then
    begin
      SetCapture(Handle);
      StartSplit(X, Y);
      FSplitting := True;
    end;
  end;
  inherited MouseDown(Button, Shift, X, Y);
end;

procedure TSplitPanel.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  if (GetCapture = Handle) and FSplitting then StepSplit(X - FSaveX, Y - FSaveY);
  inherited MouseMove(Shift, X, Y);
end;

procedure TSplitPanel.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if FSplitting then
  begin
    FSplitting := False;
    ReleaseCapture;
    StopSplit(X - FSaveX, Y - FSaveY);
    Split;
  end;
  inherited MouseUp(Button, Shift, X, Y);
end;

procedure TSplitPanel.Notification(AComponent: TComponent; AOperation: TOperation);
begin
  inherited Notification(AComponent, AOperation);
  if (AOperation = opRemove) and (AComponent = FControl) then SetControl(nil);
end;

procedure TSplitPanel.Paint;
var
  R: TRect;
begin
  with Canvas do
  begin
    Brush.Color := Color;
    case FBorderStyle of
      bsNone:
        begin
        end;
      bsRaised:
        begin
          if GetMode in [spTop, spBottom] then
            R := Rect(-2, 0, Width + 2, Height)
          else
            R := Rect(0, -2, Width, Height + 2);
          Windows.DrawEdge(Handle, R, EDGE_RAISED, BF_RECT or BF_MIDDLE);
        end;
      bsLowered:
        begin
          if GetMode in [spTop, spBottom] then
            R := Rect(-2, 0, Width + 2, Height)
          else
            R := Rect(0, -2, Width, Height + 2);
          DrawEdge(Handle, R, EDGE_SUNKEN, BF_RECT or BF_MIDDLE);
        end;
    end;
  end;
  inherited Paint;
end;

procedure TSplitPanel.Split;
begin
  if Assigned(FOnSplit) then FOnSplit(Self);
end;

{ TTrayIcon }

const
  WM_TRAYICON = WM_USER + 1;

constructor TTrayIcon.Create(AOwner: Tcomponent);
begin
  inherited Create(AOwner);
  FHandle := AllocateHWnd(WndProc);
  FIcon := TIcon.Create;
  FIcon.OnChange := IconChange;
end;

destructor TTrayIcon.Destroy;
begin
  SetVisible(False);
  DeallocateHWnd(FHandle);
  FIcon.Free;
  inherited Destroy;
end;

procedure TTrayIcon.IconChange(Sender: TObject);
begin
  UpdateIcon;
end;

procedure TTrayIcon.SetIcon(Value: TIcon);
begin
  FIcon.Assign(Value);
end;

procedure TTrayIcon.SetIconID(Value: Integer);
begin
  if FIconID <> Value then
  begin
    FIconID := Value;
    UpdateIcon;
  end;
end;

procedure TTrayIcon.SetHint(Value: string);
begin
  if FHint <> Value then
  begin
    FHint := Value;
    UpdateIcon;
  end;
end;

procedure TTrayIcon.SetPopupMenu(Value: TPopupMenu);
begin
  FPopupMenu := Value;
  if Value <> nil then Value.FreeNotification(Self);
end;

procedure TTrayIcon.SetVisible(Value: Boolean);
begin
  if FVisible <> Value then
  begin
    FVisible := Value;
    if not (csDesigning in ComponentState) then
      if Value then
        Shell_NotifyIcon(NIM_ADD, @FData)
      else
        Shell_NotifyIcon(NIM_DELETE, @FData);
  end;
end;

procedure TTrayIcon.UpdateIcon;
begin
  if not (csDesigning in ComponentState) then
  begin
    FillChar(FData, SizeOf(TNotifyIconData), 0);
    with FData do
    begin
      cbSize := SizeOf(TNotifyIconData);
      Wnd := FHandle;
      uID := FIconID;
      uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
      hIcon := FIcon.Handle;
      if Length(FHint) <> 0 then StrPLCopy(szTip, GetShortHint(FHint), SizeOf(szTip) - 1);
      uCallbackMessage := WM_TRAYICON;
    end;
    if Visible then Shell_NotifyIcon(NIM_MODIFY, @FData);
  end;
end;

procedure TTrayIcon.WndProc(var Message: TMessage);
begin
  try
    with Message do
      if (Msg = WM_TRAYICON) and (wParam = FIconID) then
        case lParam of
          WM_LBUTTONUP: Click;
          WM_LBUTTONDBLCLK: DblClick;
          WM_RBUTTONUP: Popup;
        end
      else
        Result := DefWindowProc(FHandle, Msg, wParam, lParam);
  except
    Application.HandleException(Self);
  end;
end;

procedure TTrayIcon.Click;
begin
  if Assigned(FOnClick) then FOnClick(Self);
end;

procedure TTrayIcon.DblClick;
begin
  if Assigned(FOnDblClick) then FOnDblClick(Self);
end;

procedure TTrayIcon.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (AComponent = PopupMenu) and (Operation = opRemove) then PopupMenu := nil;
end;

procedure TTrayIcon.Popup;
var
  P: TPoint;
begin
  if (PopupMenu <> nil) and PopupMenu.AutoPopup then
  begin
    GetCursorPos(P);
    SetForegroundWindow(FHandle);
    PopupMenu.PopupComponent := Self;
    PopupMenu.Popup(P.X, P.Y);
  end;
end;

{ TCheckList }

constructor TCheckList.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Style := lbOwnerDrawFixed;
  ItemHeight := 17;
  FStateList := Tlist.Create;
  FBitmap := TBitmap.Create;
  FBitmap.LoadFromResourceName(HInstance, 'BM_CHECK');
  FBitmap95 := TBitmap.Create;
  FBitmap95.LoadFromResourceName(HInstance, 'BM_CHECK95');
  FBitmap3D := TBitmap.Create;
  FBitmap3D.LoadFromResourceName(HInstance, 'BM_CHECK3D');
  FCheck95 := True;
end;

destructor TCheckList.Destroy;
begin
  ClearStateList;
  FBitmap3D.Free;
  FBitmap95.Free;
  FBitmap.Free;
  FStateList.Free;
  inherited Destroy;
end;

procedure TCheckList.ClearStateList;
var
  I: Integer;
begin
  I := FStateList.Count;
  while I > 0 do
  begin
    Dec(I);
    TCheckState(FStateList[I]).Free;
  end;
  FStateList.Clear;
end;

function TCheckList.GetChecked(Index: Integer): Boolean;
begin
  Result := False;
  if (Index >= 0) and (Index < Items.Count) then
  begin
    ValidateIndex(Index);
    Result := TCheckState(Items.Objects[Index]).Checked;
  end;
end;

function TCheckList.GetCheckRect(Index: Integer): TRect;
begin
  Result := ItemRect(Index);
  Result.Right := Result.Left + 16;
end;

function TCheckList.GetState(Index: Integer): TCheckBoxState;
begin
  Result := cbUnchecked;
  if (Index >= 0) and (Index < Items.Count) then
  begin
    ValidateIndex(Index);
    Result := TCheckState(Items.Objects[Index]).State;
  end;
end;

procedure TCheckList.SetCheck3D(Value: Boolean);
begin
  if FCheck3D <> Value then
  begin
    FCheck3D := Value;
    Invalidate;
  end;
end;

procedure TCheckList.SetCheck95(Value: Boolean);
begin
  if FCheck95 <> Value then
  begin
    FCheck95 := Value;
    Invalidate;
  end;
end;

procedure TCheckList.SetChecked(Index: Integer; Value: Boolean);
var
  State: TCheckState;
begin
  if (Index >= 0) and (Index < Items.Count) then
  begin
    ValidateIndex(Index);
    State := TCheckState(Items.Objects[Index]);
    if State.Checked <> Value then
    begin
      State.Checked := Value;
      if Value then
        State.State := cbChecked
      else
        State.State := cbUnchecked;
      ValidateCheck(Index);
    end;
  end;
end;

procedure TCheckList.SetHideSelection(Value: Boolean);
begin
  if FHideSelection <> Value then
  begin
    FHideSelection := Value;
    Invalidate;
  end;
end;

procedure TCheckList.SetState(Index: Integer; Value: TCheckBoxState);
var
  State: TCheckState;
begin
  if (Index >= 0) and (Index < Items.Count) then
  begin
    ValidateIndex(Index);
    State := TCheckState(Items.Objects[Index]);
    if State.State <> Value then
    begin
      State.State := Value;
      case Value of
        cbChecked: State.Checked := True;
        cbGrayed: State.Checked := True;
        cbUnchecked: State.Checked := False;
      end;
      ValidateCheck(Index);
    end;
  end;
end;

procedure TCheckList.ValidateCheck(Index: Integer);
var
  R: TRect;
begin
  if (Index >= 0) and (Index < Items.Count) then
  begin
    R := GetCheckRect(Index);
    InvalidateRect(Handle, @R, False);
  end;
end;

procedure TCheckList.ValidateIndex(Index: Integer);
var
  State: TCheckState;
begin
  if (Index >= 0) and (Index < Items.Count) and (Items.Objects[Index] = nil) then
  begin
    State := TCheckState.Create;
    FStateList.Add(State);
    Items.Objects[Index] := State;
  end;
end;

procedure TCheckList.CNDrawItem(var Message: TWMDrawItem);
var
  State: TOwnerDrawState;
begin
  with Message.DrawItemStruct^ do
  begin
    State := TOwnerDrawState(WordRec(LongRec(itemState).Lo).Lo);
    Canvas.Handle := hDC;
    Canvas.Font := Font;
    Canvas.Brush := Brush;
    if Integer(itemID) >= 0 then
      DrawItem(itemID, rcItem, State)
    else
      Canvas.FillRect(rcItem);
    Canvas.Handle := 0;
  end;
end;

procedure TCheckList.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  B: TBitmap;
  R, C: TRect;
begin
  with Canvas do
  begin
    if odSelected in State then
      if Focused then
      begin
        Brush.Color := clHighlight;
        Font.Color := clHighlightText;
      end
      else if not HideSelection then
      begin
        Canvas.Brush.Color := clBtnFace;
        Canvas.Font.Color := Font.Color;
      end;
    FillRect(Rect);
    if not Check3D then
      if not Check95 then
        B := FBitmap
      else
        B := FBitmap95
    else
      B := FBitmap3D;
    R := Classes.Rect(Rect.Left, Rect.Top, Rect.Left + 16, Rect.Top + 16);
    case Self.State[Index] of
      cbUnchecked: C := Classes.Rect(0, 0, 16, 16);
      cbChecked: C := Classes.Rect(16, 0, 32, 16);
      cbGrayed: C := Classes.Rect(32, 0, 48, 16);
    end;
    BrushCopy(R, B, C, clFuchsia);
    Rect.Left := Rect.Left + 16;
    TextRect(Rect, Rect.Left + 5, Rect.Top + 1, Items[Index]);
  end;
end;

procedure TCheckList.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if (ItemIndex <> -1) and (Key = VK_SPACE) then
  begin
    case State[ItemIndex] of
      cbUnchecked: State[ItemIndex] := cbChecked;
      cbChecked: State[ItemIndex] := cbUnchecked;
      cbGrayed: State[ItemIndex] := cbUnchecked;
    end;
    ValidateCheck(ItemIndex);
  end;
  inherited;
end;

procedure TCheckList.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Index: Integer;
  Rect: TRect;
begin
  if (Button = mbLeft) then
  begin
    Index := ItemAtPos(Point(X, Y), True);
    if Index <> -1 then
    begin
      Rect := GetCheckRect(Index);
      if (X >= Rect.Left) and (X < Rect.Right) then
      begin
        case State[Index] of
          cbUnchecked: State[ItemIndex] := cbChecked;
          cbChecked: State[Index] := cbUnchecked;
          cbGrayed: State[Index] := cbUnchecked;
        end;
        ValidateCheck(Index);
      end;
    end;
  end;
  inherited;
end;

constructor TCheckTree.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FImages := TImageList.Create(Self);
  FImages.ResourceLoad(rtBitmap, 'BM_CHECK', clFuchsia);
  FImages95 := TImageList.Create(Self);
  FImages95.ResourceLoad(rtBitmap, 'BM_CHECK95', clFuchsia);
  FImages3D := TImageList.Create(Self);
  FImages3D.ResourceLoad(rtBitmap, 'BM_CHECK3D', clFuchsia);
  FCheck95 := True;
  Images := FImages95;
end;

destructor TCheckTree.Destroy;
begin
  FImages3D.Free;
  FImages95.Free;
  FImages.Free;
  inherited Destroy;
end;

function TCheckTree.GetChecked(Node: TTreeNode): Boolean;
begin
  Result:= False;
  if Node <> nil then
    case Node.ImageIndex of
      0: Result := False;
      1: Result := True;
      2: Result := True;
    end;
end;

function TCheckTree.GetState(Node: TTreeNode): TCheckBoxState;
begin
  Result := cbUnchecked;
  if Node <> nil then
    case Node.ImageIndex of
      0: Result := cbUnchecked;
      1: Result := cbChecked;
      2: Result := cbGrayed;
    end;
end;

procedure TCheckTree.SetCheck3D(Value: Boolean);
begin
  if FCheck3D <> Value then
  begin
    FCheck3D := Value;
    if not Value then
      if not Check95 then
        Images := FImages
      else
        Images := FImages95
    else
      Images := FImages3D;
    Invalidate;
  end;
end;

procedure TCheckTree.SetCheck95(Value: Boolean);
begin
  if FCheck95 <> Value then
  begin
    FCheck95 := Value;
    if not Check3D then
      if not Value then
        Images := FImages
      else
        Images := FImages95
    else
      Images := FImages3D;
    Invalidate;
  end;
end;

procedure TCheckTree.SetChecked(Node: TTreeNode; Value: Boolean);
begin
  if Node <> nil then
  begin
    if not Value then
      ApplyImage(Node, 0)
    else
      ApplyImage(Node, 1);
    CheckParent(Node.Parent);
    CheckChildren(Node);
  end;
end;

procedure TCheckTree.SetState(Node: TTreeNode; Value: TCheckBoxState);
begin
  if Node <> nil then
  begin
    case Value of
      cbUnchecked: ApplyImage(Node, 0);
      cbChecked: ApplyImage(Node, 1);
      cbGrayed: ApplyImage(Node, 2);
    end;
    CheckParent(Node.Parent);
    CheckChildren(Node);
  end;
end;

procedure TCheckTree.ApplyImage(Node: TTreeNode; ImageIndex: Integer);
var
  Rect: TRect;
begin
  if (Node <> nil) and (Node.ImageIndex <> ImageIndex) then
  begin
    Node.ImageIndex := ImageIndex;
    Node.SelectedIndex := ImageIndex;
    if Node.IsVisible then
    begin
      Rect := Node.DisplayRect(False);
      InvalidateRect(Handle, @Rect, True);
    end;
  end;
end;

procedure TCheckTree.CheckChildren(Node: TTreeNode);
var
  I: Integer;
  Child: TTreeNode;
begin
  if (Node <> nil) and CheckChild then
  begin
    I := Node.ImageIndex;
    if (I = 0) or (I = 1) then
    begin
      Child := Node.GetFirstChild;
      while Child <> nil do
      begin
        ApplyImage(Child, I);
        CheckChildren(Child);
        Child := Node.GetNextChild(Child);
      end;
    end;
  end;
end;

procedure TCheckTree.CheckParent(Parent: TTreeNode);
var
  C, U: Integer;
  Node: TTreeNode;
begin
  if Parent <> nil then
  begin
    C := 0;
    U := 0;
    Node := Parent.GetFirstChild;
    while Node <> nil do
    begin
      if Node.ImageIndex > 0 then Inc(C) else Inc(U);
      if (C <> 0) and (U <> 0) and (C <> U) then Break;
      Node := Parent.GetNextChild(Node);
    end;
    if (C = 0) and (U = Parent.Count) then ApplyImage(Parent, 0)
    else if (C = Parent.Count) and (U = 0) then ApplyImage(Parent, 1)
    else ApplyImage(Parent, 2);
    CheckParent(Parent.Parent);
  end;
end;

procedure TCheckTree.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if (Selected <> nil) and (Key = VK_SPACE) and (Shift = []) then
  begin
    Checked[Selected] := not Checked[Selected];
    Key := 0;
  end;
  inherited;
end;

procedure TCheckTree.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Node: TTreeNode;
  Rect: TRect;
begin
  if (Button = mbLeft) and (Shift = [ssLeft]) then
  begin
    Node := GetNodeAt(X, Y);
    if Node <> nil then
    begin
      Rect := Node.DisplayRect(True);
      if (X >= Rect.Left - 17) and (X <= Rect.Left - 5) then
      begin
        case State[Node] of
          cbUnchecked: State[Node] := cbChecked;
          cbChecked: State[Node] := cbUnchecked;
          cbGrayed: State[Node] := cbUnchecked;
        end;
      end;
    end;
  end;
  inherited;
end;

{ TIconBox }

constructor TIconBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Style := lbOwnerDrawFixed;
  ItemHeight := GetSystemMetrics(SM_CYICON) + 6;
  Height := GetSystemMetrics(SM_CYICON) + GetSystemMetrics(SM_CYHSCROLL) + 7;
end;

procedure TIconBox.CreateList;
var
  I, Count: Integer;
  Icon: TIcon;
begin
  Count := ExtractIcon(hInstance, PChar(FIconFile), -1);
  for I := 0 to Count - 1 do
  begin
    Icon := TIcon.Create;
    Icon.Handle := ExtractIcon(hInstance, PChar(FIconFile), I);
    Items.AddObject('', Icon);
  end;
  IconIndex := 0;
end;

procedure TIconBox.DestroyList;
var
  I: Integer;
begin
  I := IconCount;
  while I > 0 do
  begin
    Dec(I);
    Icons[I] := nil;
  end;
  Items.Clear;
end;

function TIconBox.GetIcon(Index: Integer): TIcon;
begin
  Result := TIcon(Items.Objects[Index]);
end;

function TIconBox.GetIconCount: Integer;
begin
  Result := Items.Count;
end;

function TIconBox.GetIconIndex: Integer;
begin
  Result := ItemIndex;
end;

function TIconBox.GetIconPath: string;
begin
  Result := ExpandIconPath(IconFile, IconIndex);
end;

procedure TIconBox.SetIcon(Index: Integer; Value: TIcon);
begin
  Items.Objects[Index].Free;
  Items.Objects[Index] := Value;
end;

procedure TIconBox.SetIconIndex(Value: Integer);
begin
  if ItemIndex <> Value then
  begin
    ItemIndex := Value;
    Change;
  end;
end;

procedure TIconBox.SetIconFile(Value: string);
begin
  if CompareText(FIconFile, Value) <> 0 then
  begin
    FIconFile := Value;
    DestroyList;
    CreateList;
    Change;
  end;
end;

procedure TIconBox.SetIconPath(Value: string);
begin
  IconFile := ExtractIconFile(Value);
  IconIndex := ExtractIconIndex(Value);
end;

procedure TIconBox.CNDrawItem(var Message: TWMDrawItem);
var
  State: TOwnerDrawState;
begin
  with Message.DrawItemStruct^ do
  begin
    State := TOwnerDrawState(WordRec(LongRec(itemState).Lo).Lo);
    Canvas.Handle := hDC;
    Canvas.Font := Font;
    Canvas.Brush := Brush;
    if (Integer(itemID) >= 0) and (odSelected in State) then
    begin
      Canvas.Brush.Color := clHighlight;
      Canvas.Font.Color := clHighlightText
    end;
    if Integer(itemID) >= 0 then
      DrawItem(itemID, rcItem, State)
    else
      Canvas.FillRect(rcItem);
    Canvas.Handle := 0;
  end;
end;

procedure TIconBox.Change;
begin
  if Assigned(FOnChange) then FOnChange(Self);
end;

procedure TIconBox.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or LBS_DISABLENOSCROLL;
end;

procedure TIconBox.CreateWnd;
begin
  inherited CreateWnd;
  CreateList;
end;

procedure TIconBox.DestroyWnd;
begin
  DestroyList;
  inherited DestroyWnd;
end;

procedure TIconBox.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  Icon: TIcon;
  X, Y: Integer;
begin
  Icon := Icons[Index];
  if Icon <> nil then
  begin
    with Rect do
    begin
      X := Left + (Right - Left - Icon.Width) div 2;
      Y := Top + (Bottom - Top - Icon.Height) div 2;
    end;
    with Canvas do
    begin
      FillRect(Rect);
      Draw(X, Y, Icon);
    end;
  end;
end;

procedure TIconBox.MeasureItem(Index: Integer; var Height: Integer);
begin
  Height := GetSystemMetrics(SM_CYICON);
end;

procedure TIconBox.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
  inherited SetBounds(ALeft, ATop, AWidth, AHeight);
  Columns := Width div GetSystemMetrics(SM_CYICON) - 1;
end;

{ TIconDialog }

function TIconDialog.GetIconIndex: Integer;
begin
  Result := ExtractIconIndex(IconPath);
end;

function TIconDialog.GetIconFile: string;
begin
  Result := ExtractIconFile(IconPath);
end;

procedure TIconDialog.SetIconIndex(Value: Integer);
begin
  IconPath := ExpandIconPath(IconFile, Value);
end;

procedure TIconDialog.SetIconFile(Value: string);
begin
  IconPath := ExpandIconPath(Value, IconIndex);
end;

function TIconDialog.Execute: Boolean;
begin
  Result := False;
  with TIconForm.Create(Application) do
  try
    IconBox.IconPath := IconPath;
    if ShowModal = mrOK then
    begin
      IconPath := IconBox.IconPath;
      Result := True;
    end;
  finally
    Free;
  end;
end;

{ TAboutDialog }

constructor TAboutDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FProduct := '    ';
  FVersion := ' x.x ( x.x.x.x)';
  FCopyright := ' xxxx-xxxx ';
  FPicture := TPicture.Create;
  FKey := '';
end;

destructor TAboutDialog.Destroy;
begin
  FPicture.Free;
  inherited destroy;
end;

procedure TAboutDialog.SetPicture(Value: TPicture);
begin
  FPicture.Assign(Value);
end;

function TAboutDialog.Execute: Boolean;

  function GetRegCompany: string;
  begin
    Result := '';
    with TRegistry.Create do
    try
      RootKey := HKEY_LOCAL_MACHINE;
      if OpenKey(FKey, False) and ValueExists('Company') then Result := ReadString('Company');
    finally
      Free;
    end;
  end;

  function GetRegName: string;
  begin
    Result := '';
    with TRegistry.Create do
    try
      RootKey := HKEY_LOCAL_MACHINE;
      if OpenKey(FKey, False) and ValueExists('Name') then Result := ReadString('Name');
    finally
      Free;
    end;
  end;

begin
  with TAboutForm.Create(Application) do
  try
    if Length(FCaption) = 0 then
      Caption := Format(Caption, [Application.Title])
    else
      Caption := Format(Caption, [FCaption]);
    if FPicture.Graphic = nil then
      LogoImage.Picture.Graphic := Application.Icon
    else
      LogoImage.Picture.Graphic := FPicture.Graphic; 
    with ProductLabel do Caption := Format(Caption, [FProduct]);
    with VersionLabel do Caption := Format(Caption, [FVersion]);
    with CopyrightLabel do Caption := Format(Caption, [FCopyright]);
    with AdditionalLabel do Caption := Format(Caption, [FAdditional]);
    if Length(Key) <> 0 then
    begin
      with CompanyLabel do Caption := Format(Caption, [GetRegCompany]);
      with NameLabel do Caption := Format(Caption, [GetRegName]);
    end
    else
    begin
      RightsLabel.Visible := False;
      CompanyLabel.Visible := False;
      NameLabel.Visible := False;
      Divider.Top := Divider.Top - 61;
      OKButton.Top := OKButton.Top - 61;
      Height := Height - 61;
    end;
    Result := ShowModal = mrOK;
  finally
    Free;
  end;
end;

{ TFolderDialog }

function CallBack(Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM): Integer; stdcall;
begin
  Result := 0;
  if (uMsg = BFFM_INITIALIZED) and (lpData <> 0) then TFolderDialog(lpData).Init(Wnd);
end;

procedure TFolderDialog.Init(Wnd: HWND);
var
  X, Y: Integer;
  Rect: TRect;
begin
  if FPosition = poScreenCenter then
  begin
    GetWindowRect(Wnd, Rect);
    X := (GetSystemMetrics(SM_CXSCREEN) - Rect.Right + Rect.Left) div 2;
    Y := (GetSystemMetrics(SM_CYSCREEN) - Rect.Bottom + Rect.Top) div 2;
    SetWindowPos(Wnd, 0, X, Y, 0, 0, SWP_NOACTIVATE or SWP_NOSIZE or SWP_NOZORDER);
  end;
  if Length(FCaption) <> 0 then
    SendMessage(Wnd, WM_SETTEXT, 0, Longint(PChar(FCaption)));
  if Length(FFolder) <> 0 then
    SendMessage(Wnd, BFFM_SETSELECTION, 1, LPARAM(PChar(FFolder)));
end;

function TFolderDialog.Execute: Boolean;
var
  BrowseInfo: TBrowseInfo;
  ItemID: PItemIDList;
  Name, Path: PChar;
begin
  Result := False;
  Name := StrAlloc(MAX_PATH);
  Path := StrAlloc(MAX_PATH);
  try
    FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
    with BrowseInfo do
    begin
      hwndOwner := Application.Handle;
      pidlRoot  := PItemIDList(CSIDL_DRIVES);
      pszDisplayName := Name;
      lpszTitle := PChar(FTitle);
      ulFlags := BIF_RETURNONLYFSDIRS;
      lpfn := CallBack;
      lParam := Longint(Self);
    end;
    ItemID := SHBrowseForFolder(BrowseInfo);
    if ItemID <> nil then
    begin
      SHGetPathFromIDList(ItemID, Path);
      SetString(FFolder, Path, StrLen(Path));
      Result := True;
    end;
  finally
    StrDispose(Path);
    StrDispose(Name);
  end;
end;

{ TFileDialog }

constructor TFileDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCaption := '';
  FFolderLabel := '&';
  FFileNameLabel := '& ';
  FFileTypeLabel := '& ';
  FOpenCaption := '&';
  FEnableUp := True;
  FEnableCreate := True;
  FEnableRename := True;
  FEnableDelete := True;
end;

procedure TFileDialog.ChangeFileName(Sender: TObject);
begin
  FFileName := TFileDialogForm(FDialogForm).NameEdit.Text;
  if Assigned(FOnChangeFileName) then FOnChangeFileName(Self);
end;

procedure TFileDialog.ChangeFileType(Sender: TObject);
begin
  FFileType := TFileDialogForm(FDialogForm).TypeCombo.Text;
  if Assigned(FOnChangeFileType) then FOnChangeFileType(Self);
end;

procedure TFileDialog.ChangeFolder(Sender: TObject);
begin
  FFolder := TFileDialogForm(FDialogForm).FolderCombo.Text;
  if Assigned(FOnChangeFolder) then FOnChangeFolder(Self);
end;

procedure TFileDialog.CreateFolder(Sender: TObject);
begin
  DoCreateFolder;
end;

procedure TFileDialog.DialogCancel(Sender: TObject);
begin
  if not IsRenaming then DoCancelDialog else DoCancelRename;
end;

procedure TFileDialog.DialogKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if not IsRenaming then
    if Shift = [] then
      case Key of
        VK_F5: DoRefreshDialog;
      end;
end;

procedure TFileDialog.FileKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if not IsRenaming then
  begin
    if Shift = [] then
      case Key of
        VK_F2: if FEnableRename then DoRenameFile;
        VK_DELETE: if FEnableDelete then DoDeleteFile;
        VK_RETURN: DoOpenFile;
      end;
    if Shift = [ssShift] then
      case Key of
        VK_F10: DoPopup;
      end;
  end;
end;

procedure TFileDialog.FileOpen(Sender: TObject);
begin
  if not IsRenaming then DoOpenFile else DoCancelRename;
end;

procedure TFileDialog.FileRenamed(Sender: TObject; Item: TListItem; var S: string);
begin
  if Assigned(FOnRenamedFile) then FOnRenamedFile(Self, Item, S);
end;

procedure TFileDialog.FileRenaming(Sender: TObject; Item: TListItem; var AllowEdit: Boolean);
begin
  if Assigned(FOnRenamingFile) then FOnRenamingFile(Self, Item, AllowEdit);
end;

function TFileDialog.GetFileImages: TImageList;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FileImages;
end;

function TFileDialog.GetFileList: TListItems;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FileList.Items
end;

function TFileDialog.GetFileListColumns: TListColumns;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FileList.Columns;
end;

function TFileDialog.GetFileNameItem: TListItem;
var
  I: Integer;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  for I := 0 to FileList.Count - 1 do
  begin
    Result := FileList[I];
    if CompareText(Result.Caption, FileName) = 0 then Exit;
  end;
  Result := nil;
end;

function TFileDialog.GetFileTypeIndex: Integer;
begin
  if FDialogForm = nil then
  begin
    Result := -1;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).TypeCombo.ItemIndex;
end;

function TFileDialog.GetFileTypeList: TStrings;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).TypeCombo.Items;
end;

function TFileDialog.GetFolderIndex: Integer;
begin
  if FDialogForm = nil then
  begin
    Result := -1;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FolderCombo.ItemIndex;
end;

function TFileDialog.GetFolderList: TStrings;
begin
  if FDialogForm = nil then
  begin
    Result := nil;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FolderCombo.Items;
end;

function TFileDialog.GetIsRenaming: Boolean;
begin
  if FDialogForm = nil then
  begin
    Result := False;
    Exit;
  end;
  Result := TFileDialogForm(FDialogForm).FileList.IsEditing;
end;

procedure TFileDialog.SetCaption(Value: TCaption);
begin
  FCaption := Value;
  if FDialogForm <> nil then TFileDialogForm(FDialogForm).Caption := Value;
end;

procedure TFileDialog.SetEnableCreate(Value: Boolean);
begin
  FEnableCreate := Value;
  if FDialogForm <> nil then TFileDialogForm(FDialogForm).CreateButton.Enabled := Value;
end;

procedure TFileDialog.SetEnableOpen(Value: Boolean);
begin
  FEnableOpen := Value;
  if FDialogForm <> nil then TFileDialogForm(FDialogForm).OpenButton.Enabled := Value;
end;

procedure TFileDialog.SetEnableRename(Value: Boolean);
begin
  FEnableRename := Value;
  if FDialogForm <> nil then TFileDialogForm(FDialogForm).FileList.ReadOnly := Value;
end;

procedure TFileDialog.SetEnableUp(Value: Boolean);
begin
  FEnableUp := Value;
  if FDialogForm <> nil then TFileDialogForm(FDialogForm).UpButton.Enabled := Value;
end;

procedure TFileDialog.SetFileList(Value: TListItems);
begin
  if FDialogForm <> nil then
    TFileDialogForm(FDialogForm).FileList.Items := Value;
end;

procedure TFileDialog.SetFileListColumns(Value: TListColumns);
begin
  if FDialogForm <> nil then
    TFileDialogForm(FDialogForm).FileList.Columns := Value;
end;

procedure TFileDialog.SetFileName(Value: string);
begin
  FFileName := Value;
  if FDialogForm <> nil then
    TFileDialogForm(FDialogForm).NameEdit.Text := Value;
end;

procedure TFileDialog.SetFileNameLabel(Value: TCaption);
begin
  FFileNameLabel := Value;
  if FDialogForm <> nil then
    TFileDialogForm(FDialogForm).NameLabel.Caption := Value;
end;

procedure TFileDialog.SetFileType(Value: string);
begin
  FFileType := Value;
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm).TypeCombo do
      ItemIndex := Items.IndexOf(Value);
end;

procedure TFileDialog.SetFileTypeIndex(Value: Integer);
begin
  if FDialogForm <> nil then
    TFileDialogForm(FDialogForm).TypeCombo.ItemIndex := Value;
end;

procedure TFileDialog.SetFileTypeLabel(Value: TCaption);
begin
  FFileTypeLabel := Value;
  if FDialogForm <> nil then
    TFileDialogForm(FDialogForm).TypeLabel.Caption := Value;
end;

procedure TFileDialog.SetFileTypeList(Value: TStrings);
begin
  if FDialogForm <> nil then
    TFileDialogForm(FDialogForm).TypeCombo.Items := Value;
end;

procedure TFileDialog.SetFolder(Value: string);
begin
  FFolder := Value;
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm).FolderCombo do
      ItemIndex := Items.IndexOf(Value);
end;

procedure TFileDialog.SetFolderIndex(Value: Integer);
begin
  if FDialogForm <> nil then
    TFileDialogForm(FDialogForm).FolderCombo.ItemIndex := Value;
end;

procedure TFileDialog.SetFolderLabel(Value: TCaption);
begin
  FFolderLabel := Value;
  if FDialogForm <> nil then
    TFileDialogForm(FDialogForm).FolderLabel.Caption := Value;
end;

procedure TFileDialog.SetFolderList(Value: TStrings);
begin
  if FDialogForm <> nil then
    TFileDialogForm(FDialogForm).FolderCombo.Items := Value;
end;

procedure TFileDialog.SetOpenCaption(Value: TCaption);
begin
  FOpenCaption := Value;
  if FDialogForm <> nil then TFileDialogForm(FDialogForm).OpenButton.Caption := Value;
end;

procedure TFileDialog.SetPopupMenu(Value: TPopupMenu);
begin
  FPopupMenu := Value;
  if FDialogForm <> nil then TFileDialogForm(FDialogForm).FileList.PopupMenu := Value;
end;

procedure TFileDialog.UpFolder(Sender: TObject);
begin
  DoUpFolder;
end;

procedure TFileDialog.CancelDialog;
begin
  if Assigned(FOnCancelDialog) then FOnCancelDialog(Self);
end;

procedure TFileDialog.DoneDialog;
begin
  if Assigned(FOnDoneDialog) then FOnDoneDialog(Self);
end;

procedure TFileDialog.InitDialog;
begin
  if Assigned(FOnInitDialog) then FOnInitDialog(Self);
end;

procedure TFileDialog.RefreshDialog;
begin
  if Assigned(FOnRefreshDialog) then FOnRefreshDialog(Self);
end;

procedure TFileDialog.DoCancelDialog;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
    begin
      CancelDialog;
      ModalResult := mrCancel;
    end;
end;

procedure TFileDialog.DoCancelRename;
var
  FileItem: TListItem;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
    begin
      FileItem := FileList.Selected;
      if FileItem <> nil then FileItem.CancelEdit;
    end;
end;

procedure TFileDialog.DoCreateFolder;
var
  FolderItem: TListItem;
  AllowCreate: Boolean;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
    begin
      with FileList do
      begin
        if Visible then SetFocus;
        FolderItem := Items.Add;
        FolderItem.Caption := '----';
      end;
      AllowCreate := True;
      if Assigned(FOnCreateFolder) then FOnCreateFolder(Self, FolderItem, AllowCreate);
      if not AllowCreate then FolderItem.Free;
    end;
end;

procedure TFileDialog.DoDeleteFile;
var
  FileItem: TListItem;
  AllowDelete: Boolean;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
    begin
      FileItem := FileList.Selected;
      if FileItem <> nil then
      begin
        AllowDelete := True;
        if Assigned(FOnDeleteFile) then FOnDeleteFile(Self, FileItem, AllowDelete);
        if AllowDelete then FileItem.Free;
      end;
    end;
end;

procedure TFileDialog.DoOpenFile;
var
  AllowOpen: Boolean;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
      if Length(NameEdit.Text) > 0 then
      begin
        AllowOpen := True;
        if Assigned(FOnOpenFile) then FOnOpenFile(Self, FileNameItem, AllowOpen);
        if AllowOpen then ModalResult := mrOK;
      end;
end;

procedure TFileDialog.DoPopup;
var
  X, Y: Integer;
begin
  if FDialogForm <> nil then
    if FPopupMenu <> nil then
    begin
      with TFileDialogForm(FDialogForm) do
      begin
        X := FileList.ClientOrigin.X;
        Y := FileList.ClientOrigin.Y;
      end;
      FPopupMenu.Popup(X, Y);
    end;
end;

procedure TFileDialog.DoRefreshDialog;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
    begin
      RefreshDialog;
      with FolderCombo do
      begin
        ItemIndex := Items.IndexOf(FFolder);
        if ItemIndex = -1 then
        begin
          if (Items.Count = 0) and (Length(FFolder) > 0) then Items.Add(FFolder);
          if Items.Count > 0 then ItemIndex := 0;
        end;
        OnChange := ChangeFolder;
      end;
    end;
end;

procedure TFileDialog.DoRenameFile;
var
  FileItem: TListItem;
begin
  if FDialogForm <> nil then
    with TFileDialogForm(FDialogForm) do
    begin
      FileItem := FileList.Selected;
      if FileItem <> nil then
      begin
        FileList.SetFocus;
        FileItem.EditCaption;
      end;
    end;
end;

procedure TFileDialog.DoUpFolder;
begin
  if FDialogForm <> nil then
    if Assigned(FOnUpFolder) then FOnUpFolder(Self);
end;

function TFileDialog.Execute: Boolean;
var
  X, Y: Integer;
begin
  with Screen do
  begin
    X := (Width - 428) div 2;
    Y := (Height - 266) div 2;
  end;
  Result := ExecutePos(X, Y);
end;

function TFileDialog.ExecutePos(X, Y: Integer): Boolean;
begin
  FDialogForm := TFileDialogForm.Create(Application);
  try
    InitDialog;
    with TFileDialogForm(FDialogForm) do
    begin
      Left := X;
      Top := Y;
      Caption := FCaption;
      OnKeydown := DialogKeyDown;
      FolderLabel.Caption := FFolderLabel;
      with FolderCombo do
      begin
        if (Items.Count = 0) and (Length(FFolder) > 0) then
        begin
          Items.Add(FFolder);
          ItemIndex := 0;
        end;
        OnChange := ChangeFolder;
      end;
      with UpButton do
      begin
        Enabled := FEnableUp;
        OnClick := UpFolder;
      end;
      with CreateButton do
      begin
        Enabled := EnableCreate;
        OnClick := CreateFolder;
      end;
      with FileList do
      begin
        ReadOnly := not FEnableRename;
        PopupMenu := FPopupMenu;
        OnEditing := FileRenaming;
        OnEdited := FileRenamed;
        OnKeyDown := FileKeyDown;
      end;
      NameLabel.Caption := FFileNameLabel;
      with NameEdit do
      begin
        Text := FFileName;
        OnChange := ChangeFileName;
      end;
      TypeLabel.Caption := FileTypeLabel;
      with TypeCombo do
      begin
        if (Items.Count = 0) and (Length(FFileType) > 0) then
        begin
          Items.Add(FFileType);
          ItemIndex := 0;
        end;
        OnChange := ChangeFileType;
      end;
      with OpenButton do
      begin
        Caption := FOpenCaption;
        Enabled := FEnableOpen;
        OnClick := FileOpen;
      end;
      CancelButton.OnClick := DialogCancel;
      Result := ShowModal = mrOK;
    end;
    DoneDialog;
  finally
    FDialogForm.Free;
    FDialogForm := nil;
  end;
end;

end.

