{
    
    

   . 
  E-mail: roman@infra.sar.nnov.ru
}

unit Ex_File;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ComCtrls, CommCtrl, Menus;

type
  TFileDialogForm = class(TForm)
    FolderLabel: TLabel;
    FolderCombo: TComboBox;
    UpButton: TSpeedButton;
    CreateButton: TSpeedButton;
    ListButton: TSpeedButton;
    DetailsButton: TSpeedButton;
    FileList: TListView;
    NameLabel: TLabel;
    NameEdit: TEdit;
    TypeLabel: TLabel;
    TypeCombo: TComboBox;
    OpenButton: TButton;
    CancelButton: TButton;
    FileImages: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FolderComboDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FolderComboMeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure ListButtonClick(Sender: TObject);
    procedure DetailsButtonClick(Sender: TObject);
    procedure FileListChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure FileListDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FileDialogForm: TFileDialogForm;

implementation

{$R *.DFM}
{$R *.RES}

procedure TFileDialogForm.FormCreate(Sender: TObject);
begin
  with UpButton do
  begin
    Width := 23;
    Height := 22;
  end;
  with CreateButton do
  begin
    Left := UpButton.Left + 30;
    Width := 23;
    Height := 22;
  end;
  with ListButton do
  begin
    Left := CreateButton.Left + 30;
    Width := 23;
    Height := 22;
  end;
  with DetailsButton do
  begin
    Left := ListButton.Left + 23;
    Width := 23;
    Height := 22;
  end;
  FileImages.ResourceLoad(rtBitmap, 'BM_FILEICONS', clFuchsia);
end;

procedure TFileDialogForm.FolderComboDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
const
  D = DT_SINGLELINE or DT_VCENTER or DT_CALCRECT;
var
  R: TRect;
  F: Integer;
  T: string;
begin
  R.Left := Rect.Left;
  R.Right := Rect.Left;
  R.Top := Rect.Top;
  R.Bottom := Rect.Bottom;
  with FolderCombo.Canvas do
  begin
    Brush.Color := clWindow;
    FillRect(Rect);
    R.Right := R.Left + FileImages.Width + 2;
    if odSelected in State then
      F := ILD_TRANSPARENT or ILD_BLEND else
      F := ILD_NORMAL;
    if (odSelected in State) or
       (not FolderCombo.Focused and (Index = FolderCombo.ItemIndex)) then
      ImageList_Draw(FileImages.Handle, 1, Handle, R.Left + 2, R.Top, F)
    else
      ImageList_Draw(FileImages.Handle, 0, Handle, R.Left + 2, R.Top, F);
    if odFocused in State then
    begin
      Brush.Color := clHighlight;
      Font.Color := clHighlightText
    end else
    begin
      Brush.Color := clWindow;
      Font.Color := Font.Color;
    end;
    T := FolderCombo.Items[Index];
    R.Left := R.Right + 4;
    R.Right := Rect.Right;
    DrawText(Handle, PChar(T), Length(T), R, D);
    R.Right := R.Right + 1;
    R.Bottom := R.Bottom + 2;
    FillRect(R);
    TextRect(R, R.Left + 1, R.Top + 1, T);
    if odFocused in State then
    begin
      DrawFocusRect(Rect);
      DrawFocusRect(R);
    end;
  end;
end;

procedure TFileDialogForm.ListButtonClick(Sender: TObject);
begin
  FileList.ViewStyle := vsList;
end;

procedure TFileDialogForm.DetailsButtonClick(Sender: TObject);
begin
  FileList.ViewStyle := vsReport;
end;

procedure TFileDialogForm.FolderComboMeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
  Height := Canvas.TextHeight('W') + 3;
end;

procedure TFileDialogForm.FileListChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  if Change = ctState then NameEdit.Text := Item.Caption;
end;

procedure TFileDialogForm.FileListDblClick(Sender: TObject);
begin
  if FileList.Selected <> nil then OpenButton.Click;
end;

end.
