{
    
  

   . 
  E-mail: roman@infra.sar.nnov.ru
}

unit Ex_Utils;

interface

uses
  Windows, ShellAPI, SysUtils, Messages, Graphics, Controls, Forms;

type

  {    Windows }

  TWndHook = record
    Handle: THandle;
    WndProc: TWndMethod;
    Instance: Pointer;
    OldProc: Longint;
  end;

{        }

function CreateWndHook(Handle: THandle; WndProc: TWndMethod): TWndHook;

{      }

function CreateAppHook(WndProc: TWndMethod): TWndHook;

{      }

procedure FreeWndHook(Hook: TWndHook);

{    }

procedure CallWndHook(Hook: TWndHook; var Message: TMessage);

{      }

function ExtractIconFile(const IconPath: string): string;

{    }

function ExtractIconIndex(const IconPath: string): Integer;

{     }

function ExpandIconPath(const IconFile: string; IconIndex: Integer): string;

{   }

function LoadIconFromFile(const IconPath: string): HICON;

implementation

function CreateWndHook(Handle: THandle; WndProc: TWndMethod): TWndHook;
begin
  Result.Handle := Handle;
  Result.WndProc := WndProc;
  Result.Instance := MakeObjectInstance(WndProc);
  Result.OldProc := SetWindowLong(Handle, GWL_WNDPROC, Longint(Result.Instance));
end;

function CreateAppHook(WndProc: TWndMethod): TWndHook;
begin
  Result := CreateWndHook(Application.Handle, WndProc);
end;

procedure FreeWndHook(Hook: TWndHook);
begin
  with Hook do
  begin
    if OldProc <> 0 then SetWindowLong(Handle, GWL_WNDPROC, OldProc);
    if Instance <> nil then FreeObjectInstance(Instance);
  end;
end;

procedure CallWndHook(Hook: TWndHook; var Message: TMessage);
begin
  with Hook, Message do
    Result := CallWindowProc(Pointer(OldProc), Handle, Msg, wParam, lParam);
end;

function ExtractIconFile(const IconPath: string): string;
var
  I: Integer;
begin
  I := Length(IconPath);
  while (I > 0) and not (IconPath[I] in [',']) do Dec(I);
  if (I > 0) and (IconPath[I] = ',') then
    Result := Trim(Copy(IconPath, 1, I - 1)) else
    Result := Trim(IconPath);
end;

function ExtractIconIndex(const IconPath: string): Integer;
var
  I: Integer;
begin
  I := Length(IconPath);
  while (I > 0) and not (IconPath[I] in [',']) do Dec(I);
  if (I > 0) and (IconPath[I] = ',') then
    Result := StrToIntDef(Trim(Copy(IconPath, I + 1, 255)), 0) else
    Result := StrToIntDef(Trim(IconPath), 0);
end;

function ExpandIconPath(const IconFile: string; IconIndex: Integer): string;
begin
  Result := Format('%s, %d', [IconFile, IconIndex]);
end;

function LoadIconFromFile(const IconPath: string): HICON;
var
  IconFile: string;
  IconIndex: Integer;
begin
  IconFile := ExtractIconFile(IconPath);
  IconIndex := ExtractIconIndex(IconPath);
  Result := ExtractIcon(HInstance, PChar(IconFile), IconIndex);
end;

end.
