unit MC_Decode;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms;

function DecodeBase64(const S: string): string;
function DecodeQuotedPrintable(const S: string): string;

implementation

uses
  MIME, MC_Mail, MC_Cursor, MC_Consts;

function DecodeBase64(const S: string): string;
var
  Stream: TMemoryStream;
  Lines: TStringList;
begin
  SetCursor(crHourGlass);
  try
    Stream := TMemoryStream.Create;
    try
      Lines := TStringList.Create;
      try
        Lines.Text := S;
        with TBase64.Create(Stream, Lines) do
        try
          try
            Decode;
            SetString(Result, PChar(Stream.Memory), Stream.Size);
          except
            with Application do
              MessageBox(PChar(LoadStr(SBase64)), PChar(Title), MB_ICONWARNING or MB_OK);
            Result := S;
          end;
        finally
          Free;
        end;
      finally
        Lines.Free;
      end;
    finally
      Stream.Free;
    end;
  finally
    SetCursor(crDefault);
  end;
end;

function DecodeQuotedPrintable(const S: string): string;
var
  Stream: TMemoryStream;
  Lines: TStringList;
begin
  SetCursor(crHourGlass);
  try
    Stream := TMemoryStream.Create;
    try
      Lines := TStringList.Create;
      try
        Lines.Text := S;
        with TQuotedPrintable.Create(Stream, Lines) do
        try
          try
            Decode;
            SetString(Result, PChar(Stream.Memory), Stream.Size);
          except
            with Application do
              MessageBox(PChar(LoadStr(SQuotedPrintable)), PChar(Title), MB_ICONWARNING or MB_OK);
            Result := S;
          end;
        finally
          Free;
        end;
      finally
        Lines.Free;
      end;
    finally
      Stream.Free;
    end;
  finally
    SetCursor(crDefault);
  end;
end;

end.
